import dataclasses

from sohstationviewer.model.mseed.read_mseed_experiment.mseed_helper import \
    Unpacker
from sohstationviewer.model.reftek.rt130_experiment.reftek_helper import \
    PacketHeader

eh_et_payload_end = 92

def read_eh_et_packet(packet: bytes, unpacker: Unpacker):
    event_number = int(packet[16:18].hex())
    data_stream_number = int(packet[18:19].hex())
    flags = unpacker.unpack('B', packet[22:23])[0]
    data_format = packet[23:24].hex().upper()

    extended_header = EHETExtendedHeader(event_number, data_stream_number,
                                         flags, data_format)
    payload = packet[24:eh_et_payload_end]
    return extended_header, payload


@dataclasses.dataclass
class EHETExtendedHeader:
    event_number: int
    data_stream_number: int
    flags: int
    data_format: str

    def __post_init__(self):
        self.channel_number = 0
        self.number_of_samples = 0


@dataclasses.dataclass
class EHETPacket:
    header: PacketHeader
    extended_header: EHETExtendedHeader
    data: bytes
